structure Basic : BASIC = 
struct

fun isMemberEq(a,L,eq) = 
    let fun check([]) = false 
          | check(x::rest) = eq(a,x) orelse check(rest)
        in
          check(L)
    end;

fun isMember(x,L) = isMemberEq(x,L,op=);

fun remove(x,[]) = [] |
    remove(x,y::ys) = if x = y then remove(x,ys) else y::remove(x,ys);

fun removeSeveral([],y) = y |
    removeSeveral(x::xs,y) = removeSeveral(xs,remove(x,y));
    
fun removeDuplicatesEq(l,eq) = 
    let fun remove(non_dups,[]) = non_dups
          | remove(non_dups,x::xs) = if isMemberEq(x,non_dups,eq) then
                                        remove(non_dups,xs)
                                     else
                                        remove(x::non_dups,xs)
        in
           remove([],l)
    end


fun printListStr(lst,f) = 
      let fun p([]) = ""
            | p([x]) = f(x)
            | p(x::y::more) = f(x)^", "^p(y::more)
      in
         p(lst)
      end


fun printListStrWithSep(lst,f,sep) = 
      let fun p([]) = ""
            | p([x]) = f(x)
            | p(x::y::more) = f(x)^sep^p(y::more)
      in
         p(lst)
      end

fun readLine() = TextIO.inputLine(TextIO.stdIn);

fun readSexp(init_str,bp) = 
   let fun f(str) = 
              let val line = readLine()
              in
                 if line = "" then "" 
                 else
                   if (List.exists (fn c => Char.ord(c) > 32) (explode line)) then
                      let val new_str = str^line
                      in
                         if bp(new_str) then new_str else f(new_str)
                      end
                   else
                      f(str)
              end
            
   in
     (print(init_str);f(""))
   end;

end;
