type svalue = Tokens.svalue 

type pos = int * int;

type ('a,'b) token = ('a,'b) Tokens.token

type lexresult = (svalue,pos) token

val dummy_pos = (0,0);

val open_coms =  ref 0;

val mypos = ref 1;

val lines = ref 1;

fun incLines() = (lines := !lines + 1;mypos := 0);

fun incMypos(i) = mypos := !mypos + i;

fun initMypos() = mypos := 0;

fun currentPos() = (!lines,!mypos);

fun currentPos1() = {line=(!lines),pos=(!mypos)};

fun dxCurrentPos(x) = (!lines,!mypos+x);

val prog_string = ref "";

val char_code_list: int list ref = ref [];

val temp_string = ref "";

val begin_string_pos = ref (0,0);

val open_string = ref false;

val num_buffer = ref "";

val id_buffer = ref "";

val last_id_char = ref "";

val _ = Position.init();

local

fun is_reserved(str,leftp:pos as (l,p)) = 
    let fun getPos(count) = (leftp,(l,p+count-1))
        fun do_reserved "assume" = (true,Tokens.ASSUME(getPos(6))) |
            do_reserved "assert" = (true,Tokens.ASSERT(getPos(6))) | 
            do_reserved "no-types" = (true,Tokens.NO_TYPES(getPos(6))) | 
            do_reserved "minimal-output" = (true,Tokens.MINIMAL(getPos(17))) | 
            do_reserved "function" = (true,Tokens.FUNCTION(getPos(8))) | 
            do_reserved "method" = (true,Tokens.METHOD(getPos(6))) | 
            do_reserved "define" = (true,Tokens.DEFINE(getPos(6))) | 
            do_reserved "suppose-absurd" = (true,Tokens.SUPPOSE_ABSURD(getPos(14))) |
            do_reserved "dmatch" = (true,Tokens.DMATCH(getPos(6))) |
            do_reserved "match" = (true,Tokens.MATCH(getPos(5))) | 
            do_reserved "let" = (true,Tokens.LET(getPos(3))) | 
            do_reserved "in" = (true,Tokens.IN(getPos(2))) | 
            do_reserved "dlet" = (true,Tokens.DLET(getPos(4))) |
            do_reserved "fix" = (true,Tokens.FIX(getPos(3))) |
            do_reserved "end" = (true,Tokens.END(getPos(3))) |
            do_reserved "begin" = (true,Tokens.BEGIN(getPos(5))) |
            do_reserved "dbegin" = (true,Tokens.DBEGIN(getPos(6))) |
            do_reserved "BY" = (true,Tokens.BY(getPos(2))) |
            do_reserved "claim" = (true,Tokens.CLAIM(getPos(5))) |
            do_reserved "mp" = (true,Tokens.MP(getPos(2))) |
            do_reserved "cond" = (true,Tokens.COND(getPos(4))) |
            do_reserved "neg" = (true,Tokens.NEG(getPos(3))) |
            do_reserved "dn" = (true,Tokens.DN(getPos(2))) |
            do_reserved "cd" = (true,Tokens.CD(getPos(2))) |
            do_reserved "both" = (true,Tokens.BOTH(getPos(4))) |
            do_reserved "true" = (true,Tokens.TRUE(getPos(4))) |
            do_reserved "false" = (true,Tokens.FALSE(getPos(5))) |
            do_reserved "left-and" = (true,Tokens.LEFT_AND(getPos(8))) |
            do_reserved "load-file" = (true,Tokens.LOAD_FILE(getPos(9))) |
            do_reserved "right-and" = (true,Tokens.RIGHT_AND(getPos(9))) |
            do_reserved "left-either" = (true,Tokens.LEFT_EITHER(getPos(11))) |
            do_reserved "right-either" = (true,Tokens.RIGHT_EITHER(getPos(12))) |
            do_reserved "left-iff" = (true,Tokens.LEFT_IFF(getPos(8))) |
            do_reserved "right-iff" = (true,Tokens.RIGHT_IFF(getPos(9))) |
            do_reserved "equiv" = (true,Tokens.EQUIV(getPos(5))) |
            do_reserved "absurd" = (true,Tokens.ABSURD(getPos(6))) |
            do_reserved "true-intro" = (true,Tokens.TRUE_INTRO(getPos(10))) |
            do_reserved "equal" = (true,Tokens.EQ_FUN(getPos(5))) |
            do_reserved "not" = (true,Tokens.FNOT(getPos(3))) |
            do_reserved "and" = (true,Tokens.FAND(getPos(3))) |
            do_reserved "or" = (true,Tokens.FOR(getPos(2))) |
            do_reserved "if" = (true,Tokens.FIF(getPos(2))) |
            do_reserved "iff" = (true,Tokens.FIFF(getPos(3))) |
            do_reserved _ = (false,Tokens.ASSUME(dummy_pos,dummy_pos))
      in
          do_reserved(str) 
    end
in  
fun do_id(str,left_pos:pos as (l,p)) =  
                           let val (flag,tok) = is_reserved(str,left_pos) in
                               if flag then tok else 
                                  Tokens.ID(str,left_pos,(l,p+size(str)-1))
                          end;                        
end;

local
open Int;

fun int_exp(a:int,b:int) = if (b <= 0) then 1 else a*int_exp(a,b-1);

fun digit_val(c) = ord(c) - ord(#"0");

fun conv([],_,sum) = sum |
    conv(c::rest,pos,sum) = conv(rest,pos-1,sum+(digit_val(c)*int_exp(10,pos)));
in
   fun str_2_int(str) = 
       conv(explode(str),size(str)-1,0);
end;

fun getEscChar(char_list) =
     let val tail = tl(char_list)
         val first = ord(hd(tail))
     in
        if (first >= 48) andalso (first <= 57) then
           (case Int.fromString(implode(tail)) of SOME(i) => i | _ => ~1)
        else 
           if first = 94 then
              let val c = ord(hd(tl(tail))) in
                 (case c of
                     64 => 0
                   | 91 => 27
                   | 93 => 29
                   | 47 => 28
                   | 94 => 30
                   | 95 => 31
                   | _ => (if ((c >= 65) andalso (c <= 90)) then 
                               c - 64
                           else ~1))
              end
           else
           (case first of 
               92 => 92
             | 34 => 34
             | 97 => 7
             | 98 => (if null(tl(tail)) then 8 else 32)
             | 102 => 12
             | 110 => 10
             | 114 => 13
             | 116 => 9
             | 118 => 11
             | _ => ~1)
     end;

(*escape_character = \092 | \097 | \098 | \110 | \114 | \102 | \116 | \118 | \034; ****)

fun str_2_real(str) = case Real.fromString str of SOME(r) => r | _ => 0.0;

fun convert_int(str) = case Int.fromString str of SOME(r) => r | _ => 0;

fun convert_real(str) = case Real.fromString str of SOME(r) => r | _ => 0.0;

fun getInt(str) = Option.getOpt(Int.fromString(str),0);

fun getReal(str) = Option.getOpt(Real.fromString(str),0.0);

fun error(str,pos_opt) = (open_coms:= 0;open_string := false;mypos := 0; lines := 1;
                          raise AbstractSyntax.LexError(str,pos_opt));

fun inc(i) = i := !i + 1;

fun dec(i) = i := !i - 1;

fun eof() = (if ((!open_coms) > 0) then (open_coms := 0;
                                         error("unclosed comment.",NONE))
                                 else ();
             if !open_string then 
                  (open_string := false; 
                  error("unclosed string",NONE)) 
             else ();
             mypos := 0;
             lines := 1;
             Tokens.EOF(dummy_pos,dummy_pos))
%%
%header (functor NDLLexFun(structure Tokens:NDL_TOKENS));
%s EOL_COMMENT;
%s STRING;
%s INT_STATE;
%s REAL_STATE;
%s ID_STATE;
alpha = [A-Za-z];
digit = [0-9];
alpha_num = {alpha} | {digit}; 
printable_minus_backslash = [\033-\091] | [\093-\127];
init_ide_char =  \035 | \037 | [\042-\043] | \045 | [\048-\058] | \064 | [\070-\090] 
               | \094 | \095 | [\097-\125];
init_atom_char =  [\065-\069];
back_slash = \092;
back_quote = \096;
string_quote = \034;
blank = \032;
escape_character = \092 | \097 | \098 | \110 | \114 | \102 | \116 | \118 | \034;
control_character = \094;
control_letter = [\065-\090] | \064 | \091 | \093 | \047 | \094 | \095;
internal_ide_char = \033 | [\035-\037] | \039 |  
                    [\042-\043] | \045 | [\048-\058] | [\063-\091] | \094 | [\095-\125];
ide_char =  ' | _ | - | \094 | \035 | \038 | \063 | \042 | \126 | {alpha_num};
identifier = {init_ide_char}{internal_ide_char}*;
atom = {init_atom_char}{internal_ide_char}*;
non_neg_integer = {digit}+;
blank_kwd = \098\108\097\110\107;
one_two_or_three_digits = {digit} | {digit}{digit} | {digit}{digit}{digit};
escape_seq = {back_slash}{one_two_or_three_digits} | {back_slash}{escape_character} |
             {back_slash}{control_character}{control_letter} |
             {back_slash}{blank_kwd};
character1 = {back_quote}{printable_minus_backslash};
character2 = {back_quote}{escape_seq};
non_neg_number = {non_neg_integer} | {non_neg_integer}.{non_neg_integer};
number = {non_neg_number} | -{non_neg_number};
object_type_var = #{identifier};
type_var = ##{identifier};
white_space = [\ \t\b];
printable_and_non_paren = [\033-\039] | [\042-\127];
%%
<INITIAL>\n => (incLines();continue());
<INITIAL>{white_space}+ => (incMypos(size(yytext));continue());
<INITIAL>"\"" => (incMypos(1);begin_string_pos := (!lines,!mypos);
                  open_string := true;temp_string := "";
                  YYBEGIN STRING; continue());
<INITIAL>"?" => (incMypos(1);Tokens.QMARK(currentPos(),dxCurrentPos(0)));
<INITIAL>"_" => (incMypos(1);Tokens.ANY_PAT(currentPos(),dxCurrentPos(0)));
<INITIAL>"(" => (incMypos(1);Tokens.LPAREN(currentPos(),dxCurrentPos(0)));
<INITIAL>")" => (incMypos(1);Tokens.RPAREN(currentPos(),dxCurrentPos(0)));
<INITIAL>"[" => (incMypos(1);Tokens.LBRACK(currentPos(),dxCurrentPos(0)));
<INITIAL>"]" => (incMypos(1);Tokens.RBRACK(currentPos(),dxCurrentPos(0)));
<INITIAL>"!" => (incMypos(1);Tokens.EXCL_MARK(currentPos(),dxCurrentPos(0)));
<INITIAL>"," => (incMypos(1);Tokens.COMMA(currentPos(),dxCurrentPos(0)));
<INITIAL>"=" => (incMypos(1);Tokens.EQUAL_SIGN(currentPos(),dxCurrentPos(0)));
<INITIAL>{identifier} => (let val res = do_id(yytext,dxCurrentPos(1))
                          in
                             (incMypos(size(yytext));res) 
                          end);
<INITIAL>{atom} => (let val (l,p) = dxCurrentPos(1)
                    in
                      if yytext = "BY" then Tokens.BY((l,p),(l,p+size(yytext)-1))
                      else Tokens.ATOM(yytext,(l,p),(l,p+size(yytext)-1))
                    end);
<INITIAL>";" => (incMypos(1);YYBEGIN EOL_COMMENT; continue());
<INITIAL>. => (incMypos(size(yytext));
               if ord(hd(explode(yytext))) = 96 then 
                  error("Illegal character constant: "^yytext,SOME(currentPos1()))
               else error("Illegal character found and ignored: "^yytext,SOME(currentPos1()));
               continue());
<EOL_COMMENT>\n => (incLines();YYBEGIN INITIAL;continue());
<EOL_COMMENT>. => (incMypos(size(yytext));continue());



